=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class ServiceGroupResponse
    attr_accessor :description

    # String representation of an amount to be returned as the flat rate if 1. The service group is of type LIVE_RATE and no matching rates were found; or 2. The service group is of type FLAT_RATE. Either integers or decimals are accepted. Required unless type is FREE_SHIPPING
    attr_accessor :flat_rate

    # required unless type is FREE_SHIPPING
    attr_accessor :flat_rate_currency

    # optional unless type is FREE_SHIPPING
    attr_accessor :free_shipping_threshold_currency

    # For service groups of type FREE_SHIPPING, this field must be required to configure the minimum cart total (total cost of items in the cart) for this service group to be returned for rates at checkout. Optional unless type is FREE_SHIPPING
    attr_accessor :free_shipping_threshold_min

    attr_accessor :is_active

    attr_accessor :name

    attr_accessor :object_id

    attr_accessor :rate_adjustment

    attr_accessor :service_levels

    attr_accessor :type

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'description' => :'description',
        :'flat_rate' => :'flat_rate',
        :'flat_rate_currency' => :'flat_rate_currency',
        :'free_shipping_threshold_currency' => :'free_shipping_threshold_currency',
        :'free_shipping_threshold_min' => :'free_shipping_threshold_min',
        :'is_active' => :'is_active',
        :'name' => :'name',
        :'object_id' => :'object_id',
        :'rate_adjustment' => :'rate_adjustment',
        :'service_levels' => :'service_levels',
        :'type' => :'type'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'description' => :'Object',
        :'flat_rate' => :'Object',
        :'flat_rate_currency' => :'Object',
        :'free_shipping_threshold_currency' => :'Object',
        :'free_shipping_threshold_min' => :'Object',
        :'is_active' => :'Object',
        :'name' => :'Object',
        :'object_id' => :'Object',
        :'rate_adjustment' => :'Object',
        :'service_levels' => :'Object',
        :'type' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::ServiceGroupResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::ServiceGroupResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'flat_rate')
        self.flat_rate = attributes[:'flat_rate']
      end

      if attributes.key?(:'flat_rate_currency')
        self.flat_rate_currency = attributes[:'flat_rate_currency']
      end

      if attributes.key?(:'free_shipping_threshold_currency')
        self.free_shipping_threshold_currency = attributes[:'free_shipping_threshold_currency']
      end

      if attributes.key?(:'free_shipping_threshold_min')
        self.free_shipping_threshold_min = attributes[:'free_shipping_threshold_min']
      end

      if attributes.key?(:'is_active')
        self.is_active = attributes[:'is_active']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'object_id')
        self.object_id = attributes[:'object_id']
      end

      if attributes.key?(:'rate_adjustment')
        self.rate_adjustment = attributes[:'rate_adjustment']
      end

      if attributes.key?(:'service_levels')
        if (value = attributes[:'service_levels']).is_a?(Array)
          self.service_levels = value
        end
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @object_id.nil?
        invalid_properties.push('invalid value for "object_id", object_id cannot be nil.')
      end

      if @service_levels.nil?
        invalid_properties.push('invalid value for "service_levels", service_levels cannot be nil.')
      end

      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @description.nil?
      return false if @name.nil?
      return false if @object_id.nil?
      return false if @service_levels.nil?
      return false if @type.nil?
      type_validator = EnumAttributeValidator.new('Object', ['LIVE_RATE', 'FLAT_RATE', 'FREE_SHIPPING'])
      return false unless type_validator.valid?(@type)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('Object', ['LIVE_RATE', 'FLAT_RATE', 'FREE_SHIPPING'])
      unless validator.valid?(type)
        fail ArgumentError, "invalid value for \"type\", must be one of #{validator.allowable_values}."
      end
      @type = type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          description == o.description &&
          flat_rate == o.flat_rate &&
          flat_rate_currency == o.flat_rate_currency &&
          free_shipping_threshold_currency == o.free_shipping_threshold_currency &&
          free_shipping_threshold_min == o.free_shipping_threshold_min &&
          is_active == o.is_active &&
          name == o.name &&
          object_id == o.object_id &&
          rate_adjustment == o.rate_adjustment &&
          service_levels == o.service_levels &&
          type == o.type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [description, flat_rate, flat_rate_currency, free_shipping_threshold_currency, free_shipping_threshold_min, is_active, name, object_id, rate_adjustment, service_levels, type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
